((function() {

    let child_window_;

    return {
        init: function(ocaps, k) {
            window.cube_data_sources = () => ({
                primary: 'rcloud',
                sources: [
                    {
                        name: 'rcloud',
                        server: 'none',
                        provider: {
                            fetch_schema: () => ({indices: {}, measures: {
                                count: {
                                    name: 'count',
                                    type: 'quantitative',
                                    secret: {order: 1}
                                }
                            }}),
                            can_query: view => true,
                            signature: view => JSON.stringify(view), // needs to be synchronous!
                            needs_viewport: q => false, // synchronous
                            execute_query:  q => new Promise(function(resolve, reject) {
                                ocaps.execute_query(q, (error, result) => {
                                    const keys = Object.keys(result).filter(key => !/^r_/.test(key));
                                    resolve({
                                        data: result[keys[0]].map((v,i) => keys.reduce(
                                            (p,k) => (p[k] = result[k][i], p), {}))
                                    });
                                });
                            })
                        }
                    }
                ]
            });
            k();
        },
        add_dimension: function(dim, k) {
            child_window_.postMessage({
                type: 'ADD_DIMENSION',
                content: {
                    dim
                }
            });
            k();
        },
        spawn: function(url, windowName, k) {
            child_window_ = window.open(url, windowName);
            k(null, !!child_window_);
        }
    };
})());
